---
title: Web Locks API
slug: Web/API/Web_Locks_API
tags:
  - API
  - Experimental
  - LockManager
  - Overview
  - Reference
  - Web Locks API
  - lock
---
<div>{{SeeCompatTable}}{{APIRef("Web Locks")}}{{DefaultAPISidebar}}</div>

<p class="summary">The Web Locks API allows scripts running in one tab or worker to asynchronously acquire a lock, hold it while work is performed, then release it. While held, no other script executing in the same origin can acquire the same lock, which allows a web app running in multiple tabs or workers to coordinate work and the use of resources.</p>

<h2 id="Web_Locks_Concepts_and_Usage">Web Locks Concepts and Usage</h2>

<p>A lock is an abstract concept representing some potentially shared resource, identified by a name chosen by the web app. For example, if a web app running in multiple tabs wants to ensure that only one tab is syncing data between the network and Indexed DB, each tab could try to acquire a "my_net_db_sync" lock, but only one tab will succeed (the <a href="https://en.wikipedia.org/wiki/Leader_election">leader election pattern</a>.)</p>

<p>The API is used as follows:</p>

<ol>
 <li>The lock is requested.</li>
 <li>Work is done while holding the lock in an asynchronous task.</li>
 <li>The lock is automatically released when the task completes.</li>
</ol>

<pre class="brush: js">navigator.locks.request('my_resource', async lock =&gt; {
  // The lock has been acquired.
  await do_something();
  await do_something_else();
  // Now the lock will be released.
});
</pre>

<p>While a lock is held, requests for the same lock from this execution context, or from other tabs/workers, will be queued. The first queued request will be granted only when the lock is released.</p>

<p>The API provides optional functionality that may be used as needed, including:</p>

<ul>
 <li>returning values from the asynchronous task</li>
 <li>shared and exclusive lock modes</li>
 <li>conditional acquisition</li>
 <li>diagnostics to query the state of locks in an origin</li>
 <li>an escape hatch to protect against deadlocks</li>
</ul>

<p>Locks are scoped to origins; the locks acquired by a tab from https://example.com have no effect on the locks acquired by a tab from https://example.org:8080 as they are separate origins.</p>

<p>The main entry point is <code>navigator.locks.request()</code> which requests a lock. It takes a lock name, an optional set of options, and a callback. The callback is invoked when the lock is granted. The lock is automatically released when the callback returns, so usually the callback is an <em>async function</em>, which causes the lock to be released only when the async function has completely finished.</p>

<p>The <code>request()</code> method itself returns a promise which resolves once the lock has been released; within an async function, a script can <code>await</code> the call to make the asynchronous code flow linear. For example:</p>

<pre class="brush: js">await do_something_without_lock();

// Request the lock.
await navigator.locks.request('my_resource', async lock =&gt; {
  // The lock has been acquired.
  await do_something_with_lock();
  await do_something_else_with_lock();
  // Now the lock will be released.
});
// The lock has been released.

await do_something_else_without_lock();
</pre>

<h3 id="Options">Options</h3>

<p>Several options can be passed when requesting a lock:</p>

<ul>
 <li><code>mode</code>: The default mode is "exclusive", but "shared" can be specified. There can be only one "exclusive" holder of a lock, but multiple "shared" requests can be granted at the same time. This can be used to implement the <a href="https://en.wikipedia.org/wiki/Readers%E2%80%93writer_lock">readers-writer pattern</a>.</li>
 <li><code>signal</code>: An <strong>AbortSignal</strong> can be passed in, allowing a lock request to be aborted. This can be used to implement a timeout on requests.</li>
 <li><code>ifAvailable</code>: If specified, the lock request will fail if the lock cannot be granted immediately without waiting. The callback is invoked with <code>null</code>.</li>
</ul>

<h3 id="Monitoring">Monitoring</h3>

<p>The <code>navigator.locks.query()</code> method can be used by scripts to introspect the state of the lock manager for the origin. This can be useful when debugging, for example, identifying why a lock could not be acquired. The results are a snapshot of the lock manager state, which identifies held and requested locks and some additional data (e.g. mode) about each, at the time the snapshot was taken.</p>

<h3 id="Advanced_use">Advanced use</h3>

<p>For more complicated cases, such as holding the lock for an arbitrary amount of time, the callback can return a promise explicitly resolved by the script:</p>

<pre class="brush: js">// Capture promise control functions:
let resolve, reject;
const p = new Promise((res, rej) =&gt; { resolve = res; reject = rej; });

// Request the lock:
navigator.locks.request('my_resource', lock =&gt; {
  // Lock is acquired.

  return p;
  // Now lock will be held until either resolve() or reject() is called.
});

</pre>

<h3 id="Deadlocks">Deadlocks</h3>

<p>A deadlock occurs when a process can no longer make progress because each part is waiting on a request that cannot be satisfied. This can occur with this API in complex use-cases, for example, if multiple locks are requested out-of-order. If tab 1 holds lock A and tab 2 holds lock B, then tab 1 attempts to also acquire lock B and tab 2 attempts to also acquire lock A, neither request can be granted. Web applications can avoid this through several strategies, such as ensuring lock requests are not nested, or are always well ordered, or have timeouts. Note that such deadlocks only affect the locks themselves and code depending on them; the browser, other tabs, and other script in the page is not affected.</p>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("Lock")}}</dt>
 <dd>Provides the name and mode of a previously requested lock, which is received in the callback to {{domxref('LockManager.request','LockManager.request()')}}.</dd>
 <dt>{{domxref("LockManager")}}</dt>
 <dd>Provides methods for requesting a new {{domxref('Lock')}} object and querying for an existing Lock object. To get an instance of LockManager, call {{domxref('navigator.locks')}}.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Locks')}}</td>
   <td>{{Spec2('Web Locks')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="LockManager">LockManager</h3>

<p>{{Compat("api.LockManager")}}</p>

<h3 id="Lock">Lock</h3>

<p>{{Compat("api.Lock")}}</p>
